# Reference Guides Introduction

The following reference guides are technical descriptions of the Mimi machinery, organized around the actual code behind Mimi and intended to be information-oriented for those interested in the internals or needing to more deeply understand those aspects in order to carry out their projects. Given the complexity of this code base, these references are not comprehensive, but intended to target some important and relevant aspects of Mimi.

If you find a bug in these reference guides, or have a clarifying question or suggestion, please reach out via Github Issues or our [Mimi Framework forum](https://forum.mimiframework.org).  We welcome your feedback.

## Available Reference Guides

- [Reference Guide: The Mimi API](@ref) provides a guide to the public API for Mimi, including macros, types, and functions along with their signatures and descriptions.


- [Reference Guide: Structures - Classes.jl and Core Types](@ref) describes the use of Classes.jl in Mimi as well as some of the core Types used to implement Mimi 1.0.


- [Reference Guide: Structures - Definitions](@ref) describes the core _definition_ data structures used to implement Mimi 1.0.


- [Reference Guide: Structures - Instances](@ref) describes the core _instance_ data structures used to implement Mimi 1.0.

- [Reference Guide: Composite Components](@ref) describes the introduction of composite components in Mimi 1.0.
